Add stable/2310 branch to docker executor image scripts
[ci-management.git] / docker / scripts / dbld_vpp_install_packages.sh
1 #! /bin/bash
2
3 # Copyright (c) 2021 Cisco and/or its affiliates.
4 # Licensed under the Apache License, Version 2.0 (the "License");
5 # you may not use this file except in compliance with the License.
6 # You may obtain a copy of the License at:
7 #
8 #     http://www.apache.org/licenses/LICENSE-2.0
9 #
10 # Unless required by applicable law or agreed to in writing, software
11 # distributed under the License is distributed on an "AS IS" BASIS,
12 # WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
13 # See the License for the specific language governing permissions and
14 # limitations under the License.
15
16 set -euxo pipefail
17
18 export CIMAN_DOCKER_SCRIPTS=${CIMAN_DOCKER_SCRIPTS:-"$(dirname $BASH_SOURCE)"}
19 . "$CIMAN_DOCKER_SCRIPTS/lib_vpp.sh"
20 . "$CIMAN_DOCKER_SCRIPTS/lib_apt.sh"
21
22 must_be_run_in_docker_build
23
24 echo_log
25 if ! vpp_supported_executor_class "$FDIOTOOLS_EXECUTOR_CLASS" ; then
26     echo_log "VPP is not supported on executor class '$FDIOTOOLS_EXECUTOR_CLASS'. Skipping $(basename $0)..."
27     exit 0
28 else
29     echo_log "Starting  $(basename $0)"
30 fi
31
32 do_git_config vpp
33 for branch in ${VPP_BRANCHES[$OS_NAME]} ; do
34     do_git_branch "$branch"
35
36     # Install OS packages
37     make_vpp "install-dep" "$branch"
38     if [ "$OS_ID" = "ubuntu" ] && [ "$OS_ARCH" = "x86_64" ] ; then
39         # 'Make docs jobs are only run on ubuntu x86_64 executors
40         #  so only run for ubuntu build executors.
41         make_vpp "docs-venv" "$branch"
42     fi
43
44     # Download, build, and cache external deps packages
45     make_vpp "install-ext-deps" "$branch"
46     vpp_ext_dir="$DOCKER_VPP_DIR/build/external"
47     rsync -ac $vpp_ext_dir/downloads/. $DOCKER_DOWNLOADS_DIR || true
48     if which apt >/dev/null ; then
49         vpp_ext_deps_pkg=$vpp_ext_dir/$(dpkg -l vpp-ext-deps 2>/dev/null | mawk '/vpp-ext-deps/{print $2"_"$3"_"$4".deb"}')
50     else
51         echo "ERROR: Package Manager not installed!"
52         exit 1
53     fi
54     if [ -f "$vpp_ext_deps_pkg" ] ; then
55         cp -f $vpp_ext_deps_pkg $DOCKER_DOWNLOADS_DIR
56     else
57         echo "ERROR: Missing VPP external deps package: '$vpp_ext_deps_pkg'"
58         exit 1
59     fi
60     # Install/cache python packages
61     make_vpp_test "test-dep" "$branch"
62     if [ "$OS_ID" = "ubuntu" ] ; then
63         make_vpp test-wipe "$branch"
64     fi
65     # Clean up virtual environment
66     git checkout -q -- .
67     git clean -qfdx
68
69     # Dump packages installed
70     case "$DOCKERFILE_FROM" in
71         *ubuntu*)
72             dump_apt_package_list "$branch" ;;
73         *debian*)
74             dump_apt_package_list "$branch" ;;
75     esac
76 done
77
78 echo_log -e "Completed $(basename $0)!\n\n=========="